> ## Documentation Index
> Fetch the complete documentation index at: https://docs.runloop.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Download binary file contents from Devbox filesystem.

> Download file contents of any type (binary, text, etc) from a specified path on the Devbox.



## OpenAPI

````yaml /openapi-specs/stainless-processed-openapi.json post /v1/devboxes/{id}/download_file
openapi: 3.1.0
info:
  title: RunLoop API
  version: '0.1'
  description: >-
    The RunLoop API spec that allows you to host lambda functions and Devboxes
    to enable scaled long running ai workflows.
  contact:
    name: Runloop AI Support
    url: https://runloop.ai
    email: support@runloop.ai
servers:
  - url: https://api.runloop.ai
    description: Runloop API
    variables: {}
security:
  - bearerAuth: []
tags:
  - name: Benchmark
  - name: Blueprint
  - name: Blueprint-Lifecycle
  - name: Blueprint-ObservabilityTools
  - name: Devbox
  - name: Devbox-FileTools
  - name: Devbox-Lifecycle
  - name: Devbox-NetworkTools
  - name: Devbox-ObservabilityTools
  - name: Devbox-PersistenceTools
  - name: Devbox-ShellTools
  - name: Scenario
  - name: ScenarioScorer
  - name: accounts
  - name: agents
  - name: apikeys
  - name: axons
  - name: executions
  - name: gateway-configs
  - name: mcp-configs
  - name: network-policies
  - name: objects
  - name: restricted_keys
  - name: secrets
  - name: streaming
paths:
  /v1/devboxes/{id}/download_file:
    post:
      tags:
        - Devbox
        - Devbox-FileTools
      summary: Download binary file contents from Devbox filesystem.
      description: >-
        Download file contents of any type (binary, text, etc) from a specified
        path on the Devbox.
      operationId: devboxDownloadFile
      parameters:
        - name: id
          in: path
          description: The Devbox ID.
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/DevboxDownloadFileParameters'
      responses:
        '200':
          description: OK
          content:
            application/octet-stream:
              schema:
                format: binary
          headers:
            Content-Type:
              description: application/octet-stream
              required: true
              schema:
                type: string
            Content-Disposition:
              description: attachment
              required: true
              schema:
                type: string
        '404':
          description: Devbox not found.
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Runloop from '@runloop/api-client';


            const client = new Runloop({
              bearerToken: process.env['RUNLOOP_API_KEY'], // This is the default and can be omitted
            });


            const response = await client.devboxes.downloadFile('id', { path:
            'path' });


            console.log(response);


            const content = await response.blob();

            console.log(content);
        - lang: Python
          source: |-
            import os
            from runloop_api_client import Runloop

            client = Runloop(
                bearer_token=os.environ.get("RUNLOOP_API_KEY"),  # This is the default and can be omitted
            )
            response = client.devboxes.download_file(
                id="id",
                path="path",
            )
            print(response)
            content = response.read()
            print(content)
components:
  schemas:
    DevboxDownloadFileParameters:
      type: object
      properties:
        path:
          type: string
          description: >-
            The path on the Devbox filesystem to read the file from. Path is
            relative to user home directory.
      required:
        - path
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````